// Copyright (C) 2021 The Qt Company Ltd.
// SPDX-License-Identifier: LicenseRef-Qt-Commercial OR GPL-3.0-only WITH Qt-GPL-exception-1.0

import QtQuick 2.15
import QtQuick.Layouts 1.15
import HelperWidgets 2.0
import StudioTheme 1.0 as StudioTheme

Section {
    anchors.left: parent.left
    anchors.right: parent.right
    caption: qsTr("Stack Layout")

    SectionLayout {
        PropertyLabel {
            text: qsTr("Current index")
            tooltip: qsTr("Sets the index of the child item currently visible in the <b>Stack Layout</b>.")
        }

        SecondColumnLayout {
            SpinBox {
                implicitWidth: StudioTheme.Values.twoControlColumnWidth
                               + StudioTheme.Values.actionIndicatorWidth
                backendValue: backendValues.currentIndex
                minimumValue: 0
                maximumValue: 1000
                decimals: 0
            }

            ExpandingSpacer {}
        }
    }
}
